package deployer

// This function rebuilds an image if either the git hash changed, or any of the building recipe file changed.
// This function supposes the project-deployer file structure respect the Labomatic™ convention (not really a trademark)
func UpdateDockerImage(imageName string) {
	imageTag := REGISTRY_IMAGE + ":" + imageName + "-" + ENVIRONMENT_NAME
	imageBuildconfDir := PROJECT_ROOT + "/image/" + imageName

	// TODO: update only when needed

	// // Get up to date image from registry, and compare the "git.hash" label to update only if project changed
	// ExecAllowingErr(PROJECT_ROOT, Cmd("docker", "pull", imageTag))
	// oldGitHash := ExecStr(PROJECT_ROOT, Cmd("docker", "inspect", "-f", "{{ index .ContainerConfig.Labels \"git.hash\" }}", imageTag))
	// oldDockerfileHash := ExecStr(PROJECT_ROOT, Cmd("docker", "inspect", "-f", "{{ index .ContainerConfig.Labels \"buildconf.hash\" }}", imageTag))
	// newGitHash := ExecStr(PROJECT_ROOT, Cmd("git", "-C", modulePath, "rev-parse", "HEAD"))
	// newBuildconfHash := ExecStr(PROJECT_ROOT, Cmd("git", "ls-tree", "-r", "HEAD", imageBuildconfDir))

	// if oldGitHash == newGitHash && oldDockerfileHash == newDockerfileHash {
	// 	Echof("Skipping update of image %s (git.hash=%s)", imageName, newGitHash)
	// } else {
	// Echof("Update of image %s (git.hash=%s)", imageName, newGitHash)
	Echof("Update of image %s", imageName)
	Exec(PROJECT_ROOT, Cmd(
		"docker", "build",
		// "--label", "git.hash="+newGitHash,
		// "--label", "buildconf.hash="+newBuildHash,
		"-t", imageTag,
		"-f", imageBuildconfDir+"/Dockerfile",
		"$PROJECT_ROOT",
	))
	Exec(PROJECT_ROOT, Cmd("docker", "push", imageName))
	// }
}
