package deployer

import (
	"crypto/sha256"
	"encoding/binary"
	"encoding/hex"
	"fmt"
	"hash"
	"io"
	"os"
	"path/filepath"
)

// func Sha256(filePath string) string {
// 	file, err := os.Open(filePath)
// 	ThrowIfErr(err)
// 	defer file.Close()
// 	hash := sha256.New()
// 	_, err = io.Copy(hash, file)
// 	ThrowIfErr(err)
// 	return hex.EncodeToString(hash.Sum(nil)[:])
// }

// Computes a deterministic sha256 for a list of files and directories.
// Each file content is hashed
// Each directory is recursively hashed, ignoring .dotfiles and throwing errors on sockets, devices, etc.
func Sha256(h hash.Hash, path string) string {
	return Hash(h, path)
}

func Hash(h hash.Hash, path string) string {
	fmt.Printf("aa\n")
	filepath.Walk(path, func(p string, info os.FileInfo, err error) error {
		relativePath := p[len(path):]
		mode := info.Mode()
		modeInBytes := []byte{0, 0, 0, 0}
		binary.LittleEndian.PutUint32(modeInBytes, uint32(mode))

		if len(relativePath) > 0 {
			fmt.Printf("path=%s name=%s isdir=%v\n", relativePath, info.Name(), info.IsDir())
		}
		return nil
	})

	file, err := os.Open(path)
	ThrowIfErr(err)
	defer file.Close()
	hash := sha256.New()
	_, err = io.Copy(hash, file)
	ThrowIfErr(err)
	return hex.EncodeToString(hash.Sum(nil)[:])
}

// filepath.Walk(p, func(path string, info os.FileInfo, err error) error {
// 	relativePath := path[len(p):]
// 	if len(relativePath) > 0 {
// 		fmt.Printf("path=%s name=%s isdir=%v\n", relativePath, info.Name(), info.IsDir())
// 	}
// 	return nil
// })
//        ModeDir        FileMode = 1 << (32 - 1 - iota) // d: is a directory
//        ModeAppend                                     // a: append-only
//        ModeExclusive                                  // l: exclusive use
//        ModeTemporary                                  // T: temporary file; Plan 9 only
//        ModeSymlink                                    // L: symbolic link
//        ModeDevice                                     // D: device file
//        ModeNamedPipe                                  // p: named pipe (FIFO)
//        ModeSocket                                     // S: Unix domain socket
//        ModeSetuid                                     // u: setuid
//        ModeSetgid                                     // g: setgid
//        ModeCharDevice                                 // c: Unix character device, when ModeDevice is set
//        ModeSticky                                     // t: sticky
